#include "../xuser.h"

char const
    xuser[]         = "XUser",
    nullstring[]    = "",
    zerostring[]    = "0",
    fivestring[]    = "5",
    sevenstring[]   = "7",
    r[]             = "r",
    w[]             = "w";

USER_
    *up = 0,
    *user = 0;

long
    pwchange,
    inact,
    min,                                    // # of days relative to 
    max,                                    // their base-values
    warn,
    expire,
    today;

unsigned    
    errors,
    hidden_objects = 0,
    nrmlist = 0,                                
    nusers = 0;

FL_FORM
    *f_browsegroup,
    *f_browseerror,
    *f_main,
    *f_browseshell,
    *f_browseuid,
    *f_browsename,
    *f_passwd;

FL_OBJECT
    *cancel_passwd,
    *no_shadow_entry,
    *leave_namebrowser,
    *name_button,
    *name_0_button,
    *nopasswd,
    *hide_group,
    *copyright,
    *pwd1group,
    *pwd2group,
    *pwdinput1,
    *pwdinput2,
    *button_group,
    *leave_groupbrowser,
    *namebrowser,
    *groupbrowser,
    *leave_shellbrowser,
    *shellbrowser,
    *leave_uidbrowser,
    *uidbrowser,
    *errorbrowser,
    *leave_errorbrowser,
    *name,
    *uid,
    *gid,
    *dir,
    *shell,
    *fullname,
    *office1,
    *office2,
    *address,
    *uid_button,
    *gid_button,
    *shell_button,
    *accept_button,
    *save_button,
    *cancel_button,
    *exit_button,
    *make_button,
    *files_ok_button,
    *delete_button,
    *rm_rf_button,
    *spwchg,
    *smin,
    *smax,
    *swarn,
    *sinact,
    *sexpire,
    *ssetpw;
char
    **rmlist = 0,
    *pwd;

APP_DEFAULTS_
    app_defaults;

static char 
    _shells[]                   = "*shells",
    _passwd[]                   = "*passwd",
    _shadow[]                   = "*shadow",
    _skeleton[]                 = "*skeleton",
    _backup[]                   = "*backup",
    _length[]                   = "*length",
    _fixed[]                    = "*fixed",
    _change[]                   = "*change",
    _alert[]                    = "*alert",
    _entry[]                    = "*entry",
    _expiration[]               = "*expiration",
    _group[]                    = "*group",
    _groups[]                   = "*groups",
    _shell[]                    = "*shell",
    _home[]                     = "*home",
    _options[]                  = "*options",
    _unlimited[]                = "*unlimited",
    _shadow_defaults[]          = "*force-shadow-defaults",
    _sortgroups[]               = "*sort-group-names";

FL_CMD_OPT
    cmdopt[] =
    {
        {"-shells",     _shells,      XrmoptionSepArg, 0},
        {"-passwd",     _passwd,      XrmoptionSepArg, 0},
        {"-shadow",     _shadow,      XrmoptionSepArg, 0},
        {"-skeleton",   _skeleton,    XrmoptionSepArg, 0},
        {"-backup",     _backup,      XrmoptionSepArg, 0},
        {"-length",     _length,      XrmoptionSepArg, 0},
        {"-fixed",      _fixed,       XrmoptionSepArg, 0},
        {"-change",     _change,      XrmoptionSepArg, 0},
        {"-alert",      _alert,       XrmoptionSepArg, 0},
        {"-entry",      _entry,       XrmoptionSepArg, 0},
        {"-expiraton",  _expiration,  XrmoptionSepArg, 0},
        {"-group",      _group,       XrmoptionSepArg, 0},
        {"-groups",     _groups,      XrmoptionSepArg, 0},
        {"-shell",      _shell,       XrmoptionSepArg, 0},
        {"-home",       _home,        XrmoptionSepArg, 0},
        {"-options",    _options,     XrmoptionNoArg,  "True"},
        {"-unlimited",  _unlimited,   XrmoptionSepArg, 0},
        {"-force",      _shadow_defaults,   XrmoptionNoArg,  "True"},
        {"-sortgroups", _sortgroups,        XrmoptionNoArg,  "True"},
    };

FL_resource
    res[] =
    {
        {_backup + 1,   xuser, FL_STRING, 0, "-",           250},
        {_group + 1,    xuser, FL_STRING, 0, nullstring,    250},
        {_groups + 1,   xuser, FL_STRING, 0, "/etc/group",  250},
        {_home + 1,     xuser, FL_STRING, 0, "/home",       250},
        {_passwd + 1,   xuser, FL_STRING, 0, "/etc/passwd", 250},
        {_shadow + 1,   xuser, FL_STRING, 0, "/etc/shadow", 250},
        {_shell + 1,    xuser, FL_STRING, 0, nullstring,    250},
        {_shells + 1,   xuser, FL_STRING, 0, "/etc/shells", 250},
        {_skeleton + 1, xuser, FL_STRING, 0, "/etc/skel",   250},


        {_length + 1,   xuser, FL_INT,  &app_defaults.length,   fivestring},
        {_fixed + 1,    xuser, FL_INT,  &app_defaults.fixed,    zerostring},
        {_change + 1,   xuser, FL_INT,  &app_defaults.change,   zerostring},
        {_alert + 1,    xuser, FL_INT,  &app_defaults.alert,    sevenstring},
        {_entry + 1,    xuser, FL_INT,  &app_defaults.entry,    sevenstring},
        {_expiration + 1,   xuser, FL_INT,  &app_defaults.expiration,
                                                                zerostring},
        {_unlimited + 1,    xuser, FL_INT,  &app_defaults.unlimited,
                                                                "10000"},

        {_options + 1,  xuser, FL_BOOL, &app_defaults.options,  zerostring},
        {_shadow_defaults + 1,  xuser, FL_BOOL, &app_defaults.force_sh,
                                                                zerostring},
        {_sortgroups + 1,       xuser, FL_BOOL, &app_defaults.sort_groups,
                                                                zerostring},
    };

unsigned
    sizeof_cmdopt   = sizeof(cmdopt)    /   sizeof(FL_CMD_OPT),
    sizeof_res      = sizeof(res)       /   sizeof(FL_resource);
